<!--suppress CheckEmptyScriptTag, HtmlDeprecatedTag -->
<style scoped>
    .olapic-logo {
        height: 41px;
        float: left;
        padding: 5px;
        margin: 5px 10px 0 15px;
        border-radius: 5px;
        background-color: #fff;
        background-color: rgba(255, 255, 255, 0.6);
    }

    .map-title {
        color: #fff;
        padding: 10px 0;
        background: #333;
        text-align: center;
    }
    .map-title h1 {
        font-size: 1.2rem;
    }

    .map-inteface {
        overflow: hidden;
    }

    .interface-boot {
        background-color: #eee;
    }
    .interface-boot > div {
        text-align: center;
    }

    .interface-error {
        text-align: center;
        color: #333;
    }

    .position-node:hover {
        cursor: pointer;
    }

    .map-inteface-buttons {
        width: 100%;
        display: inline-grid;
        grid-template-columns: 50% 50%;
        grid-template-rows: 50px;
    }
    .map-inteface-buttons .item {
        align-self: stretch;
        grid-row-start: 1;
    }
    .map-inteface-buttons .item.a {
        grid-column: 1 / span 1;
    }
    .map-inteface-buttons .item.b {
        grid-column: 2 / span 1;
    }
</style>

<template>
    <div>
        <div class="map-title">
            <a href="http://www.olapic.com/">
                <svg class="olapic-logo" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" id="Logo" x="0px" y="0px" viewBox="0 0 1280 430" style="enable-background:new 0 0 1280 430;" xml:space="preserve">
                 <g>
                  <title>Olapic</title>
                     <g id="svg_1">
                   <g id="svg_9">
                    <g id="svg_8">
                     <path d="m575.4,299.4l-22.6,14.6l0,7l0.2,0l105,0l0.2,0l0,-7l-26.9,-14.6l0,-50.4c8.2,4 19.1,6.2 32.6,6.2c17.8,0 32.9,-5.1 46,-14.7c25.7,-19.9 36.4,-49 36.4,-82c0,-42.9 -27.4,-73.3 -63.8,-73.3c-21.5,0 -42.7,12.5 -51.1,25.9l1.1,-25.4l-8.1,0l-71.4,26.9l0,7.1l22.5,7.9l-0.1,171.8m83,-57.4c-16.4,-0.1 -27.1,-11.6 -27.1,-32.1l0,-87.5c2.4,-2.3 10.9,-8.3 22.5,-8.3c26.8,0 38.1,26.6 38.1,61.5c0,43.3 -10.6,66.3 -33.5,66.4z" id="svg_1"></path>
                        <polygon points="338.20001220703125,231.5 338.20001220703125,231.5 338.20001220703125,10.699996948242188 329.3999938964844,10.699996948242188 259.70001220703125,37.600006103515625 259.70001220703125,44.600006103515625 259.70001220703125,44.69999694824219 282.29998779296875,52.5 282.29998779296875,231.5 282.29998779296875,231.5 259.70001220703125,246.10000610351562 259.70001220703125,253.10000610351562 259.8999938964844,253.10000610351562 360.5999755859375,253.10000610351562 360.79998779296875,253.10000610351562 360.79998779296875,246.10000610351562 " id="svg_2"></polygon>
                        <path d="m960.3,255.2c-44.1,0 -84.2,-33.6 -84.2,-86c0,-40.9 22.6,-69.4 58.6,-80.1c45.8,-13.6 85.1,15.8 85.1,15.8l-27.2,46.1l-5.6,0c0,0 -15.4,-60.7 -46.9,-49.5c-20.8,7.3 -22.9,46.8 -11.8,72.2c10.8,24.9 31.8,43.8 62.6,43.8c30.6,0 42.9,-22.1 42.9,-22.1l6.7,2.2c-5.2,17.9 -31.7,57.6 -80.2,57.6z" id="svg_3"></path>
                        <polygon points="841.5999755859375,85.19999694824219 841.5999755859375,231.5 866.2999877929688,246.10000610351562 866.2999877929688,253.10000610351562 760.9000244140625,253.10000610351562 760.9000244140625,246.10000610351562 785.5999755859375,231.5 785.5999755859375,126.5 763,119.29998779296875 763,112.10000610351562 834,85.19999694824219 " id="svg_4"></polygon>
                        <ellipse ry="32.2" rx="34.3" cy="33" cx="811.6" id="svg_5"></ellipse>
                        <path d="m528.4,215.3l0,-73.8c0,-50.1 -39.6,-56.3 -69.9,-56.3c-35.5,0 -75.1,15.4 -80.3,19.7l27.5,46.5l6.7,0c2.7,-8.6 11.2,-53.8 39.7,-53.8c13,0 23.3,8.3 23.3,30.4c0,14.7 0,23.5 0,23.5c-24.2,3.2 -47.1,7.6 -70.1,18.2c-23,11 -32.4,24.5 -32.4,44.3c0,21.1 17.1,41.2 46.2,41.2c25.4,0 45.3,-14.2 56.2,-29.3l4.7,29.4l6.7,0l64.4,-24.9l0,-7.1l-22.7,-8zm-53.1,-0.9c0,0 -8.7,6.6 -24,6.6c-14.1,0 -25.9,-8.2 -25.9,-22.1s13,-29.3 49.9,-35.6l0,51.1z" id="svg_6"></path>
                        <path d="m15,142.8c0,-69 49.6,-113.6 116.9,-113.6c67.3,0 114.9,44.6 114.9,113.6c0,69 -49.2,113.6 -116.6,113.6c-67.3,0 -115.2,-44.6 -115.2,-113.6zm162.8,0c0,-67.7 -20.8,-98.8 -47.9,-98.8c-26.8,0 -45.9,31.2 -45.9,98.8c0,67.7 20.4,98.5 47.2,98.5c27.2,0 46.6,-30.8 46.6,-98.5z" id="svg_7"></path>
                    </g>
                   </g>
                         <g id="svg_20">
                    <path id="svg_10" d="m771.1,344.1l-7.4,-4.1l0,-1.2l15.2,-4.8l0.5,0.4l0,26.9c0.8,-0.7 1.8,-1.4 2.7,-2.1s2,-1.3 3.1,-1.8c1.1,-0.5 2.2,-1 3.4,-1.3c1.1,-0.3 2.3,-0.5 3.4,-0.5c2.4,0 4.5,0.5 6.5,1.4c2,0.9 3.7,2.3 5.1,4c1.4,1.7 2.5,3.8 3.3,6.2c0.8,2.4 1.2,5 1.2,7.9c0,3.9 -0.6,7.4 -1.8,10.4c-1.2,3 -2.8,5.6 -4.8,7.7c-2,2.1 -4.2,3.8 -6.8,4.9c-2.5,1.1 -5.1,1.7 -7.7,1.7c-2.8,0 -5.1,-0.3 -7.1,-1c-1.9,-0.7 -3.6,-1.4 -4.9,-2.1l-3.4,2.7l-0.5,0l0,-55.3zm16.2,17.4c-1.4,0 -2.8,0.3 -4.1,0.9c-1.4,0.6 -2.6,1.3 -3.8,2l0,28c1.2,0.9 2.6,1.6 4.1,2.3c1.5,0.6 3.1,0.9 4.8,0.9c1.7,0 3.2,-0.4 4.6,-1.2c1.4,-0.8 2.6,-1.9 3.6,-3.4c1,-1.5 1.8,-3.3 2.3,-5.3c0.6,-2.1 0.8,-4.4 0.8,-6.9c0,-3 -0.4,-5.6 -1.1,-7.8c-0.7,-2.2 -1.7,-4 -2.9,-5.4c-1.2,-1.4 -2.5,-2.5 -4,-3.1c-1.4,-0.7 -2.9,-1 -4.3,-1z"></path>
                             <path id="svg_11" d="m833.2,395.6l0,-0.2l-3.5,0l-13.7,-33.9l-4.7,-1.8l0,-2.4l20.2,0l0,2.1l-6.9,1.3l10.8,28l0.2,0l10.5,-27.2l-6.3,-1.8l0,-2.4l14.2,0l0,2.1l-3.6,1.3l-16,41.1c-1.4,3.3 -2.8,6 -4.3,8.1c-1.5,2.1 -3,3.8 -4.5,4.9c-1.5,1.2 -2.8,2 -4.1,2.4c-1.2,0.4 -2.3,0.7 -3.1,0.7c-1.8,0 -3.2,-0.4 -4.2,-1.3c-1,-0.9 -1.5,-2.1 -1.5,-3.8c0,-1.1 0.3,-2.2 0.9,-3.2c0.6,-1 1.2,-1.9 2,-2.5l0.2,0l8.1,2.6c0.4,0 0.9,-0.1 1.4,-0.3c0.5,-0.2 1.1,-0.6 1.7,-1.1c0.6,-0.6 1.2,-1.4 1.9,-2.5c0.7,-1.1 1.3,-2.5 2,-4.3l2.3,-5.9z"></path>
                             <path id="svg_12" d="m880.5,350.3l-6.6,-3.1l0,-2.4l15.9,0l15.9,39.3l0.4,0l16,-39.3l14.5,0l0,3l-5.8,1.5l3,44.7l6.6,1.5l0,3l-23.1,0l0,-2.5l7.7,-3.1l-2,-39.5l-0.2,0l-18,43.2l-2.8,0l-17.1,-40.5l-0.2,0l-2.4,37.8l8.5,1.5l0,3l-20.1,0l0,-2.4l6.7,-3.1l3.1,-42.6z"></path>
                             <path id="svg_13" d="m945.9,378c0,-3.4 0.5,-6.5 1.6,-9.3c1.1,-2.8 2.5,-5.1 4.5,-7c1.9,-1.9 4.2,-3.4 6.9,-4.5c2.7,-1.1 5.6,-1.6 8.8,-1.6c2.9,0 5.5,0.6 7.9,1.7c2.3,1.1 4.3,2.6 5.9,4.5c1.6,1.9 2.8,4.2 3.7,6.8c0.9,2.6 1.3,5.4 1.3,8.3c0,3.4 -0.5,6.5 -1.4,9.2c-0.9,2.8 -2.4,5.2 -4.2,7.2c-1.9,2 -4.2,3.6 -6.9,4.7c-2.7,1.1 -5.8,1.7 -9.3,1.7c-3,0 -5.6,-0.6 -7.9,-1.7c-2.3,-1.1 -4.3,-2.6 -5.9,-4.6c-1.6,-2 -2.8,-4.3 -3.7,-6.9s-1.3,-5.4 -1.3,-8.5zm9.3,-2c0,3.5 0.2,6.5 0.6,8.9c0.4,2.5 1.1,4.5 2.1,6c0.9,1.6 2.2,2.7 3.7,3.4s3.3,1.1 5.5,1.1c2,0 3.7,-0.4 5,-1.3c1.3,-0.9 2.4,-2.1 3.1,-3.5c0.8,-1.4 1.3,-3.1 1.6,-4.9c0.3,-1.8 0.4,-3.7 0.4,-5.7c0,-2.9 -0.1,-5.6 -0.4,-8.1c-0.2,-2.5 -0.8,-4.6 -1.6,-6.4c-0.8,-1.8 -2,-3.2 -3.6,-4.2c-1.6,-1 -3.6,-1.5 -6.2,-1.5c-1.9,0 -3.5,0.4 -4.8,1.3c-1.3,0.8 -2.4,2 -3.2,3.5c-0.8,1.5 -1.4,3.2 -1.7,5.2c-0.3,1.8 -0.5,4 -0.5,6.2z"></path>
                             <path id="svg_14" d="m1023.4,355.6c2.7,0 4.9,0.5 6.4,1.5c1.5,1 2.6,2.3 3.3,3.8s1.1,3.4 1.3,5.5c0.1,2.1 0.2,4.2 0.2,6.3l0,22l7.4,1l0,2.7l-21,0l0,-1.3l5.2,-3.9l0,-20.8c0,-1.2 -0.1,-2.3 -0.2,-3.6c-0.1,-1.2 -0.5,-2.3 -1,-3.3c-0.6,-1 -1.4,-1.8 -2.6,-2.5c-1.2,-0.7 -2.8,-1 -4.9,-1c-1.4,0 -2.9,0.3 -4.5,0.9c-1.7,0.6 -3.1,1.4 -4.2,2.3l0,29.4l6.7,1l0,2.7l-22.5,0l0,-1.3l7.4,-3.9l0,-27.6l-7.4,-4.2l0,-1.1l15.1,-4.8l0.6,0.5l-1,6.8l0.2,0.1c0.6,-0.6 1.4,-1.3 2.4,-2.1s2.2,-1.6 3.6,-2.4c1.4,-0.8 2.9,-1.4 4.5,-2c1.5,-0.4 3.2,-0.7 5,-0.7z"></path>
                             <path id="svg_15" d="m1047,378c0,-3.4 0.5,-6.5 1.6,-9.3c1.1,-2.8 2.5,-5.1 4.5,-7c1.9,-1.9 4.2,-3.4 6.9,-4.5c2.7,-1.1 5.6,-1.6 8.8,-1.6c2.9,0 5.5,0.6 7.9,1.7c2.3,1.1 4.3,2.6 5.9,4.5c1.6,1.9 2.8,4.2 3.7,6.8c0.9,2.6 1.3,5.4 1.3,8.3c0,3.4 -0.5,6.5 -1.4,9.2c-0.9,2.8 -2.4,5.2 -4.2,7.2c-1.9,2 -4.2,3.6 -6.9,4.7c-2.7,1.1 -5.8,1.7 -9.3,1.7c-3,0 -5.6,-0.6 -7.9,-1.7c-2.3,-1.1 -4.3,-2.6 -5.9,-4.6c-1.6,-2 -2.8,-4.3 -3.7,-6.9s-1.3,-5.4 -1.3,-8.5zm9.3,-2c0,3.5 0.2,6.5 0.6,8.9c0.4,2.5 1.1,4.5 2.1,6c0.9,1.6 2.2,2.7 3.7,3.4s3.3,1.1 5.5,1.1c2,0 3.7,-0.4 5,-1.3c1.3,-0.9 2.4,-2.1 3.1,-3.5c0.8,-1.4 1.3,-3.1 1.6,-4.9c0.3,-1.8 0.4,-3.7 0.4,-5.7c0,-2.9 -0.1,-5.6 -0.4,-8.1c-0.2,-2.5 -0.8,-4.6 -1.6,-6.4c-0.8,-1.8 -2,-3.2 -3.6,-4.2c-1.6,-1 -3.6,-1.5 -6.2,-1.5c-1.9,0 -3.5,0.4 -4.8,1.3c-1.3,0.8 -2.4,2 -3.2,3.5c-0.8,1.5 -1.4,3.2 -1.7,5.2c-0.3,1.8 -0.5,4 -0.5,6.2z"></path>
                             <path id="svg_16" d="m1110.8,399.4c-2.6,0 -4.7,-0.5 -6.1,-1.4c-1.4,-0.9 -2.5,-2.2 -3.2,-3.7c-0.7,-1.6 -1.1,-3.3 -1.2,-5.3c-0.1,-2 -0.2,-4.1 -0.2,-6.2l0,-20.5l-7.4,0l0,-1.3l7.4,-5.7l7,-7.2l1.3,0l0,9.3l14.1,0l-0.8,4.8l-13.4,0l0,20.6c0,1.3 0.1,2.5 0.2,3.8c0.1,1.3 0.4,2.4 0.8,3.4c0.4,1 1.1,1.9 2.1,2.5c0.9,0.7 2.2,1 3.8,1c1.4,0 2.6,-0.2 3.8,-0.7c1.2,-0.5 2.5,-1.2 3.8,-2.3l1.6,2.1c-0.7,0.6 -1.5,1.3 -2.5,2.1c-1,0.8 -2.1,1.5 -3.3,2.2c-1.2,0.7 -2.5,1.3 -3.8,1.8c-1.3,0.5 -2.7,0.7 -4,0.7z"></path>
                             <path id="svg_17" d="m1146.7,395.6l0,-0.2l-3.5,0l-13.7,-33.9l-4.7,-1.8l0,-2.4l20.2,0l0,2.1l-6.9,1.3l10.8,28l0.2,0l10.5,-27.2l-6.3,-1.8l0,-2.4l14.2,0l0,2.1l-3.6,1.3l-16,41.1c-1.4,3.3 -2.8,6 -4.3,8.1c-1.5,2.1 -3,3.8 -4.5,4.9c-1.5,1.2 -2.8,2 -4.1,2.4c-1.2,0.4 -2.3,0.7 -3.1,0.7c-1.8,0 -3.2,-0.4 -4.2,-1.3c-1,-0.9 -1.5,-2.1 -1.5,-3.8c0,-1.1 0.3,-2.2 0.9,-3.2c0.6,-1 1.2,-1.9 2,-2.5l0.2,0l8.1,2.6c0.4,0 0.9,-0.1 1.4,-0.3c0.5,-0.2 1.1,-0.6 1.7,-1.1c0.6,-0.6 1.2,-1.4 1.9,-2.5c0.7,-1.1 1.3,-2.5 2,-4.3l2.3,-5.9z"></path>
                             <path id="svg_18" d="m1193.6,414.4l0,2.7l-24.7,0l0,-1.3l7.4,-3.9l0,-46.2l-7.4,-4.2l0,-1.1l15.1,-4.8l0.6,0.5l-1,6.7l0.2,0c0.8,-0.7 1.7,-1.4 2.8,-2.3c1.1,-0.8 2.2,-1.6 3.4,-2.4c1.2,-0.7 2.4,-1.3 3.7,-1.8c1.3,-0.5 2.6,-0.7 3.8,-0.7c2.4,0 4.5,0.5 6.5,1.4c2,0.9 3.7,2.3 5.1,4c1.4,1.7 2.5,3.8 3.3,6.2s1.2,5 1.2,7.9c0,3.9 -0.6,7.4 -1.8,10.4c-1.2,3 -2.8,5.6 -4.8,7.7c-2,2.1 -4.2,3.8 -6.8,4.9c-2.5,1.1 -5.1,1.7 -7.7,1.7c-2.7,0 -5.2,-0.4 -7.7,-1.2l0,14.2l8.8,1.6zm-9,-21.9c1.2,0.9 2.6,1.6 4.1,2.3c1.5,0.6 3.1,0.9 4.9,0.9c1.7,0 3.2,-0.4 4.6,-1.2s2.6,-1.9 3.6,-3.4c1,-1.5 1.7,-3.3 2.3,-5.3c0.6,-2.1 0.8,-4.4 0.8,-6.9c0,-3 -0.4,-5.6 -1.1,-7.7c-0.7,-2.1 -1.7,-3.8 -2.9,-5.1c-1.2,-1.3 -2.5,-2.3 -4,-2.9c-1.4,-0.6 -2.9,-0.9 -4.4,-0.9c-1.4,0 -2.7,0.3 -4.1,0.9c-1.4,0.6 -2.6,1.3 -3.8,2.1l0,27.2z"></path>
                             <path id="svg_19" d="m1220.8,378.6c0,-3.3 0.5,-6.4 1.5,-9.2c1,-2.8 2.4,-5.2 4.3,-7.2c1.9,-2 4.2,-3.6 7,-4.8c2.7,-1.2 5.9,-1.7 9.5,-1.7c2.1,0 4,0.4 5.7,1.1c1.7,0.8 3.1,1.8 4.2,3.1c1.1,1.3 2,2.9 2.6,4.6c0.6,1.8 0.9,3.7 0.9,5.7c0,0.6 0,1.1 -0.1,1.7c-0.1,0.5 -0.1,1.1 -0.2,1.7l-0.2,0.2l-26.5,0l0,1.1c0,3.3 0.4,6.1 1.2,8.5s1.8,4.3 3.1,5.9c1.3,1.6 2.8,2.8 4.5,3.5c1.7,0.8 3.4,1.1 5.1,1.1c1.3,0 2.5,-0.2 3.6,-0.5c1.2,-0.3 2.2,-0.7 3.2,-1.2c1,-0.5 1.9,-1 2.7,-1.5c0.8,-0.6 1.5,-1.1 2.2,-1.5l1.8,2.8c-2.1,2.2 -4.6,4.1 -7.4,5.6c-2.8,1.5 -6,2.3 -9.4,2.3c-3.1,0 -5.9,-0.6 -8.3,-1.7c-2.4,-1.1 -4.4,-2.6 -6,-4.5c-1.6,-1.9 -2.9,-4.2 -3.7,-6.8c-0.9,-2.6 -1.3,-5.4 -1.3,-8.3zm18.6,-19.8c-1.6,0 -2.9,0.3 -4.1,1c-1.1,0.7 -2.1,1.6 -2.9,2.7c-0.8,1.1 -1.4,2.4 -1.9,3.8c-0.4,1.4 -0.8,2.9 -1,4.3l16.7,-1.1c0.2,-1.1 0.2,-2.1 0.2,-2.8c0,-1.6 -0.2,-3 -0.8,-4c-0.5,-1 -1.1,-1.8 -1.9,-2.4c-0.7,-0.6 -1.5,-1 -2.3,-1.2c-0.6,-0.2 -1.3,-0.3 -2,-0.3z"></path>
                   </g>
                  </g>
                 </g>
                </svg>
            </a>
            <h1 v-show="!isMobile">Please select a location on the map (the circles)</h1>
            <h1 v-show="isMobile" style="font-size: 1rem;">Navigate by using the buttons<br><small>(Previous and Next)</small></h1>
            <p v-show="!isMobile">This will get a list of images for the selected location</p>
        </div>
        <div :id="id" class="map-inteface" :style="{ height: getMaxHeight + 'px' }">
            <div :style="{ height: getInterfaceHeight + 'px', marginTop: getInterfaceMarginTop + 'px', marginLeft: getInterfaceMarginLeft + 'px' }">
                <div v-show="show.error" class="interface-error"
                     :style="{ height: getInterfaceHeight + 'px', paddingTop: getPaddingTop + 'px' }">
                    <div class="fa-6x" :style="{ color: color }">
                        <i class="fa fa-robot"></i>
                    </div>
                    <h3 :style="{ color: color }" v-html="messages.error.genericTitle"></h3>
                    <p v-html="messages.error.text"></p>
                </div>
                <div v-show="show.loading" class="interface-boot"
                     :style="{ height: getInterfaceHeight + 'px', paddingTop: getPaddingTop + 'px' }">
                    <div class="fa-6x" :style="{ color: color }">
                        <i class="fas fa-spinner fa-pulse"></i>
                    </div>
                </div>
                <!-- map goes here -->
                <div v-show="show.map" class="interface-map"
                     :style="{ height: getInterfaceHeight + 'px' }">
                    <world :width="getMapWidth" :color="color" :strokeColor="strokeColor">
                        <g>
                            <circle v-for="position in iss.positions"
                                    :class="getNodeClass"
                                    :cx="position.cx" :cy="position.cy" :r="iss.radius"
                                    :stroke="getStrokeColor(position)"
                                    :fill="getStrokeColor(position)"
                                    :fill-opacity="getIssNodeOpacity(position)" stroke-width="0.1"
                                    @click="setSelectedByNode(position)" />
                        </g>
                        <image v-if="iss.positions.length > 0"
                               :class="getNodeClass"
                               xlink:href="../../../images/iss.png"
                               :x="iss.positions[0].cx - (iss.size / 2)"
                               :y="iss.positions[0].cy - (iss.size / 2)"
                               :height="iss.size + 'px'" :width="iss.size + 'px'"
                               @click="setSelectedByNode(iss.positions[0])"/>
                    </world>
                </div>
            </div>
        </div>
        <div v-show="isMobile && show.map" class="map-inteface-buttons">
            <div class="item a">
                <a class="button is-primary is-large is-fullwidth" @click="selectPrevNode()">
                    <span class="icon is-small">
                        <i class="fas fa-angle-left"></i>
                    </span>
                    <span>Previous</span>
                </a>
            </div>
            <div class="item b">
                <a class="button is-info is-large is-fullwidth" @click="selectNextNode()">
                    <span>Next</span>
                    <span class="icon is-small">
                        <i class="fas fa-angle-right"></i>
                    </span>
                </a>
            </div>
        </div>
    </div>
</template>

<!--suppress NodeModulesDependencies -->
<script>
    // noinspection JSUnusedGlobalSymbols
    export default {
        name: "IssInterface",

        data: function() {
            return {
                show: {
                    loading: true, // Boolean to show the loading interface
                    error: false, // Boolean to show the error interface
                    map: false // Boolean to show the map interface
                },
                messages: {
                    error: {
                        genericTitle: 'Ooops! This is embarrasing, we have an error on this page.',
                        text: 'Please contact the app admin, we probably just need a new phalange'
                    }
                },
                iss: {
                    size: 7, // Size to assign to the iss icon
                    radius: 1, // Radius to assign to each position (approx 200km^2)
                    selectedID: null, // Reference to the currently selected position by ID
                    positions: [] // List of all available ISS positions (including latest)
                },
                viewBox: { // The coordinate max values of the map svg
                    width: 201,
                    height: 97
                },
                id: 'iss-interface', // Id to assign to this component
                width: 600, // Width of map wrapper
                height: 320 // Viewport height
            }
        },

        props: {
            color: { // Color to assign to each point in the world map
                type: String,
                default: '#1AB3FF'
            },
            unselectedStrokeColor: { // Color to assign to positions that are not selected
                type: String,
                default: '#00d1b2'
            },
            strokeColor: { // Color to assign to the selected position
                type: String,
                default: '#0080E6'
            }
        },

        computed: {
            /**
             * Returns TRUE if resolution is wrapper width is below 768px;
             * @return boolean
             */
            isMobile: function () {
                return this.width <= 768;
            },
            /**
             * Get the full height to assign to the world map. The height depends on the
             * map width and is related based on a 320/600 ratio.
             *
             * I didn't simplify the 320/600 to 8/15 in order to remind myself that this
             * ratio is based on the original svg map dimensions
             * @return number
             */
            getInterfaceHeight: function () {
                return Math.ceil((320 * this.getMapWidth) / 600);
            },
            /**
             * The maximum allowed height the map may have on the UI (the map should
             * generally not go beyond the viewport's height). Under ideal circumstances,
             * the map may occupy 70% of the viewport.
             * @return number
             */
            getMaxHeight: function () {
                let interfaceHeight = this.getInterfaceHeight,
                    percentOperator = 0.7,
                    maxHeight,
                    minHeight = 400;

                if (interfaceHeight < 1 || this.height < 1) {
                    return 100;
                }
                if (this.isMobile) {
                    percentOperator = 0.5;
                    minHeight = 300;
                }
                maxHeight = this.height * percentOperator;
                if (maxHeight > interfaceHeight) {
                    maxHeight = interfaceHeight;
                }
                if (maxHeight < minHeight) {
                    maxHeight = minHeight;
                }

                // noinspection JSSuspiciousNameCombination
                return Math.floor(maxHeight);
            },
            /**
             * The loading and error page have text content to show the user, this padding
             * is meant to vertically center that content with respect to the map height
             * @return number
             */
            getPaddingTop: function () {
                return Math.floor(((this.getMaxHeight - 56) / 2) - 17);
            },
            /**
             * Determine the width to assign to the svg map (this also indirectly determines
             * the map height). The map will try to be of equal width to the map wrapper, but
             * will have a minimum width of 1400px (this is to guarantee legibility in mobile
             * devices).
             * @return number
             */
            getMapWidth: function () {
                return this.width < 1400 ? 1400 : this.width;
            },

            /**
             * Determine the currently selected position by using iss.selectedID data attr.
             * Since the ISS positions refresh every 60 seconds, the id stored
             * in iss.selectedID will eventually not be available anymore, if that happens,
             * then we'll select the latest ISS position (triggering a refresh of the images).
             * @return Array
             */
            getSelectedIisNode: function () {
                let selectedID = this.iss.selectedID,
                    selected = this.iss.positions.filter((item) => {
                        return item.id === selectedID;
                    }),
                    prevID;

                if (selected.length === 0 && this.iss.positions > 0) {
                    selected = [ this.iss.positions[0] ];
                    prevID = this.iss.selectedID;
                    this.iss.selectedID = selected.id;
                    if (this.iss.selectedID !== prevID) {
                        this.updateMedia();
                    }
                }
                return selected.length === 0 ? [] : selected[0];
            },
            /**
             * Determine what class to use for nodes/positions. For desktop, we want the pointer
             * to be shown.
             * @return string
             */
            getNodeClass: function() {
                return this.isMobile ? '' : 'position-node';
            },
            /**
             * We always want to have the currently selected position to be as vertically
             * centered as possible (and we must have it visible within the viewable section
             * of the map). To manipulate the position of the map with respect to the visible
             * area, we determine the marginTop attribute
             * @return number
             */
            getInterfaceMarginTop: function () {
                let interfaceHeightPX = this.getInterfaceHeight,
                    maxHeightPX = this.getMaxHeight,
                    interfaceHeight = this.viewBox.height,
                    maxHeight;

                // Determine max Height in viewBox parameters
                maxHeight = (interfaceHeight * maxHeightPX) / interfaceHeightPX;

                if (maxHeight >= interfaceHeight) {
                    return 0;
                }
                let maxMargin,
                    finalMargin,
                    selected = this.getSelectedIisNode;

                maxMargin = interfaceHeight - maxHeight;

                // Vertically center selected node
                if (maxHeight / 2 >= selected.cy) {
                    return 0;
                }
                finalMargin = selected.cy - (maxHeight / 2);

                if (finalMargin > maxMargin) {
                    finalMargin = maxMargin;
                }

                // Translate margin back to pixels
                finalMargin = (interfaceHeightPX * finalMargin) / interfaceHeight;

                finalMargin = Math.round(finalMargin * 100) / 100;

                return -1 * finalMargin;
            },
            /**
             * We always want to have the currently selected position to be as horizontally
             * centered as possible (and we must have it visible within the viewable section
             * of the map). To manipulate the position of the map with respect to the visible
             * area, we determine the marginLeft attribute
             * @return number
             */
            getInterfaceMarginLeft: function () {
                let mapWidthPX = this.getMapWidth,
                    mapWidth = this.viewBox.width,
                    interfaceWidth;

                // Determine the interface width in terms of the viewBox parameters
                interfaceWidth = (mapWidth * this.width) / mapWidthPX;
                if (interfaceWidth >= mapWidth - 1) {
                    return 0;
                }

                let maxMargin,
                    finalMargin,
                    selected = this.getSelectedIisNode;

                maxMargin = mapWidth - interfaceWidth;

                // Horizontally center selected node
                if (interfaceWidth / 2 >= selected.cx) {
                    return 0;
                }
                finalMargin = selected.cx - (interfaceWidth / 2);

                if (finalMargin > maxMargin) {
                    finalMargin = maxMargin;
                }

                // Translate margin back to pixels
                finalMargin = (finalMargin * mapWidthPX) / mapWidth;

                finalMargin = Math.round(finalMargin * 100) / 100;

                return -1 * finalMargin;
            }
        },

        methods: {
            /**
             * Set Map to loading
             */
            showLoading: function () {
                this.show.loading = true;
                this.show.error = false;
                this.show.map = false;
            },
            /**
             * Set map to viewable
             */
            showMap: function () {
                this.show.loading = false;
                this.show.error = false;
                this.show.map = true;
            },
            /**
             * Set Map to error
             */
            showError: function () {
                this.show.loading = false;
                this.show.error = true;
                this.show.map = false;
            },

            /**
             * This method is called on a resize event. It'll update this.width to the new
             * map wrapper width and this.height to the new viewport height.
             */
            adjustWH: function () {
                this.width = document.getElementById(this.id).offsetWidth;
                this.height =
                    Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
            },

            /**
             * Get the color to assign to the position described by node. If this position is
             * currently selected, then return this.strokeColor, else return
             * this.unselectedStrokeColor
             * @param node - describes a position
             * @return string returns hex color
             */
            getStrokeColor: function (node) {
                return this.getSelectedIisNode.id === node.id ? this.strokeColor : this.unselectedStrokeColor;
            },
            /**
             * Each position has a stroke and a fill attribute. We assign a higher opacity
             * to the selected position and a lower opacity to the unselected positions
             * @param node - describes a position
             * @return number returns an opacity (min: 0, max: 1)
             */
            getIssNodeOpacity: function (node) {
                return node.id === this.iss.selectedID ? 0.9 : 0.4;
            },

            /**
             * Converts a latitude and longitude into a value compatible with the svg draw area.
             * @param latitude - latitude to convert
             * @param longitude - longitude to convert
             * @return Object - object with x and y keys
             */
            convertGeoToNodePosition: function (latitude, longitude) {
                let viewBox = this.viewBox,
                    equator = 54,
                    primeMeridian = 89,
                    hemisphereWidth = 112,
                    lat = parseFloat(latitude),
                    lng = parseFloat(longitude),
                    x = 0,
                    y = 0;

                // Resolve latitude
                y += equator;
                if (lat <= 0) {
                    lat = Math.abs(lat);
                    y += (equator / 90) * lat;
                } else {
                    lat = Math.abs(lat);
                    y -= (equator / 90) * lat;
                }
                if (y < 1) {
                    y = 1;
                }
                if (y > viewBox.height) {
                    y = viewBox.height;
                }

                // Resolve longitude
                x += primeMeridian;
                if (lng >= 0) {
                    lng = Math.abs(lng);
                    x += (hemisphereWidth / 180) * lng;
                } else {
                    lng = Math.abs(lng);
                    x -= (hemisphereWidth / 180) * lng;
                }
                if (x > -4 && x < 0) {
                    x = 1;
                }
                if (x < 0) {
                    return null;
                }
                if (x < 1) {
                    x = 1;
                }
                if (x > viewBox.width && x < viewBox.width + 4) {
                    x = viewBox.width - 1;
                }
                if (x > viewBox.width) {
                    return null;
                }

                return {
                    x: x,
                    y: y
                };
            },

            /**
             * Update the positions stored in the component to the latest list procured from
             * the API. Each position will be stored by a set of nodes as described below;
             *  positions = [
             *      ...
             *      node: {
             *          id: String,         // Unique ID for this position/node
             *          index: Integer,     // position index (lower is more recent)
             *          moment: Date,       // The datetime this node was procured
             *          latitude: Number,   // Position's latitude
             *          longitude: Number,  // Position's longitude
             *          cx: Number,         // Position's center point (x axis) in svg coordinate
             *          cy: Number          // Position's center point (y axis) in svg coordinate
             *      },
             *      ...
             *  ];
             * @param positions - The latest list of positions procured from the server
             * @param selectLatestNode - Determine if we change the selected position to the
             *                           latest position
             */
            setISSPositions: function (positions, selectLatestNode) {
                let totalPositions = 18,
                    selectedNode = this.getSelectedIisNode,
                    finalID;

                if (typeof selectLatestNode === 'undefined') {
                    selectLatestNode = false;
                }
                if (positions.length === 0) {
                    this.showMap();
                    return;
                }
                finalID = selectLatestNode ? 0 : selectedNode.id;
                this.iss.positions = [];
                let printIndex = 0;
                for (let i = 0; i < positions.length; i++) {
                    if (i >= totalPositions) {
                        break;
                    }
                    let currentPosition = positions[i],
                        nodePos;

                    nodePos = this.convertGeoToNodePosition(
                        currentPosition.latitude, currentPosition.longitude
                    );
                    if (nodePos === null) {
                        continue;
                    }
                    if (finalID === printIndex) {
                        finalID = currentPosition.id;
                    }
                    this.iss.positions.push({
                        id: currentPosition.id,
                        index: printIndex,
                        moment: new Date(currentPosition.moment),
                        latitude: currentPosition.latitude,
                        longitude: currentPosition.longitude,
                        cx: nodePos.x,
                        cy: nodePos.y
                    });
                    printIndex++;
                }
                this.setSelectedByID(finalID);
                this.showMap();
            },

            /**
             * Update the selected position based on its unique id. If the desired id no
             * longer exists, then we select the latest position.
             * @param id - The desired position's unique id
             */
            setSelectedByID: function (id) {
                let matched = null,
                    prevID;

                this.iss.positions.forEach((item) => {
                    if (item.id === id) {
                        matched = item;
                    }
                });
                if (matched === null && this.iss.positions.length > 0) {
                    matched = this.iss.positions[0];
                }
                prevID = this.iss.selectedID;
                this.iss.selectedID = matched === null ? null : matched.id;
                if (matched !== null) {
                    if (this.iss.selectedID !== prevID) {
                        this.updateMedia();
                    }
                }
            },
            /**
             * Update the selected position based on an object describing it. If the desired
             * position no longer exists, then the latest position will be selected
             *
             * This functionality is enabled for desktop mode only
             * @param node - Object describing the position
             */
            setSelectedByNode: function (node) {
                if (this.isMobile) {
                    return;
                }
                this.setSelectedByID(node.id);
            },
            /**
             * Update the selected position based on its index. Positions are sorted by an
             * ascending index order. A lower index describes a more recent position; the
             * latest position has an index of 0.
             * @param index - integer describing the index to use
             */
            setSelectedByIndex: function (index) {
                if (this.iss.positions.length === 0) {
                    return;
                }

                let node = this.iss.positions.filter((currNode) => {
                    return currNode.index === index;
                });

                if (node.length === 0) {
                    this.setSelectedByID(this.iss.positions[0].id);
                    return;
                }
                this.setSelectedByID(node[0].id);
            },
            /**
             * This method selects the previous position that's available (previous being
             * one position newer than the currently selected position). If the current
             * position is the latest position, then the latest position is selected
             */
            selectNextNode: function() {
                let currIndex,
                    nextIndex;

                if (this.iss.positions.length === 0) {
                    return;
                }
                currIndex =
                    this.getSelectedIisNode.count === 0 ? 1 : this.getSelectedIisNode.index;
                nextIndex = currIndex - 1;
                if (nextIndex < 0) {
                    this.setSelectedByIndex(0);
                    return;
                }
                return this.setSelectedByIndex(nextIndex);
            },
            /**
             * This method selects the next position that's available (next being one position
             * older than the currently selected position). If the current position is the
             * oldest position, then the oldest position is selected.
             */
            selectPrevNode: function() {
                let currIndex,
                    prevIndex;

                if (this.iss.positions.length === 0) {
                    return;
                }
                currIndex =
                    this.getSelectedIisNode.count === 0 ? -1 : this.getSelectedIisNode.index;
                prevIndex = currIndex + 1;
                if (prevIndex < this.iss.positions.length) {
                    this.setSelectedByIndex(prevIndex);
                    return;
                }
                return this.setSelectedByIndex(this.iss.positions.length - 1);
            },

            /**
             * Get the latest list of positions and then update the UI.
             * @param selectANode - Indicate that a node should get selected after procuring
             *                      data
             */
            getISSPositions: function (selectANode) {
                if (typeof selectANode === 'undefined') {
                    selectANode = false;
                }
                // noinspection ES6ModulesDependencies,JSUnresolvedVariable
                axios.get(issEnvVars.urls.iss.get)
                    .then((response) => {
                        if (!response.data) {
                            this.showError();
                            console.log(response);
                            return;
                        }
                        this.setISSPositions(response.data, selectANode);
                    })
                    .catch((error) => {
                        this.showError();
                        console.log(error);
                    });
            },

            /**
             * The selected position has changed, update the media
             */
            updateMedia: function () {
                let selected = this.getSelectedIisNode;

                if (selected.length === 0) {
                    // Set media to no media
                    return;
                }
                let lat = selected.latitude,
                    lng = selected.longitude;

                this.$root.notifyUpdateMedia(lat, lng);
            }
        },

        mounted() {
            // Make sure we're loading
            this.showLoading();

            // Set up event listener for resize event
            this.adjustWH();
            window.addEventListener('resize', () => {
                this.adjustWH();
            });

            // Fetch data
            this.getISSPositions(true);

            // Set up auto refresh every minute
            setInterval(() => {
                this.getISSPositions();
            }, 60000);
        }
    }
</script>